/***************************************************************************
 *            lists-fun.c
 *
 *  Tue Oct 25 15:57:56 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomcio-j@o2.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glade/glade.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>

#include "lists-fun.h"
#include "interface-fun.h"

/*
 *	Funkcja tworzy liste 'main_list' w oknie 'main_win'
 */

void	create_main_list			(void)	{
	GtkTreeStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (main_win);
	treeview = glade_xml_get_widget (xml, "main_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 0);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 2);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Type"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 3);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_visible (GTK_TREE_VIEW_COLUMN (column), FALSE);
	
	store = gtk_tree_store_new (4, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL (store));
}

/*
 *	Funkcja tworzy liste w oknie 'menage_db_win'
 */

void	create_menage_db_list			(GtkWidget	*widget)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (widget);
	treeview = glade_xml_get_widget (xml, "items_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 0);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL (store));
}

/*
 *	Funkcja tworzy liste w oknie 'search_win'. Ostatnia kolumna jest ukryta.
 *	przechowuje ona wartosc '0' lub '1', '0' jezeli ksiazka jest ksiazka 
 *	jednotomowa, '1' jezeli ksiazka jest pozycja wielotomowa. Ukeyte pole jest 
 *	ustawiane przez funkcje w pliku 'search-fun.c'
 */

void	create_search_list			(GtkWidget	*widget)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (widget);
	treeview = glade_xml_get_widget (xml, "books_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 2);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Type"));
	
	store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja tworzy modele list w trzech oknach. Ustala sie ja za pomoca zmiennej
 *	'mode':
 *		- 0 - odpowiada za liste w oknie 'main_win'
 *		- 1 - odpowiada za liste w oknie 'm_book_win'
 *		- 2 - odpowiada za liste 'selected_books_list' w oknie 'select_book_dlg'
 *		- 3 - odpowiada za liste 'available_books_list' w oknie 'select_book_dlg'
 *		- 4 - odpowiada za liste w oknie 'property_win'
 */

void	create_books_list			(GtkWidget	*widget,
									 gint		mode)
{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	switch (mode)	{
		case 0:
			treeview = glade_xml_get_widget (xml, "m_books_list");
			break;
		case 1:
			treeview = glade_xml_get_widget (xml, "books_list");
			break;
		case 2:
			treeview = glade_xml_get_widget (xml, "selected_books_list");
			break;
		case 3:
			treeview = glade_xml_get_widget (xml, "available_books_list");
			break;
		case 4:
			treeview = glade_xml_get_widget (xml, "books_list");
			break;
	}
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	store = gtk_list_store_new (1, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(store));
}

/*	
 *	Funkcja tworzy listw 'm_books_list' w oknie 'main_win'.
 */

void	create_main_win_m_books_list	(void)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (main_win);
	treeview = glade_xml_get_widget (xml, "m_books_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Subtitle"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(store));
}

/*	
 *	Funkcja tworzy listw 'books_list' w oknie 'property_dlg'.
 */

void	create_property_dlg_books_list	(GtkWidget	*widget)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (widget);
	treeview = glade_xml_get_widget (xml, "books_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Subtitle"));
	
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL (store));
}

/*	
 *	Funkcja tworzy listw w oknie 'm_book_win'. Lista pelni role bufora
 */

void	create_m_volume_list		(GtkWidget	*widget)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (widget);
	treeview = glade_xml_get_widget (xml, "books_list");
	/*	ID tomu, kolumna - 0	*/
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 0);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	/*	Tytul tomu, kolumna - 1	*/
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Subtitle"));
	gtk_tree_view_column_set_cell_data_func(column, renderer, m_book_list_mark_row, NULL, NULL);
	/*	Adres do struktury przechowywujacej dane o ksiazce, kolumna - 2	*/
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 2);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
		
	/*	Przechowuje 1 jezeli ksiazka zostala zaznaczona do usunieci lub 0 gdy 
	 *	nie jest przeznaczona do usuniecia ksiazka, kolumna - 10	*/
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 3);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	/*	Przechowuje wartosc 1 gdy tom po zaladowaniu okna 'm_books_win' byl 
	 *	edytowany lub 0 gdy nie edytowano informacji o tomie	*/
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 4);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	store = gtk_list_store_new (5, G_TYPE_INT, G_TYPE_STRING, G_TYPE_INT,
		G_TYPE_INT, G_TYPE_INT);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL (store));
}

/*
 *	Funkcja tworzy liste 'search_books_list' w oknie 'search_win'
 */

void	create_search_books_list			(GtkWidget	*widget)	{
	GtkListStore		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget			*treeview;
	GladeXML			*xml;
	
	xml = glade_get_widget_tree (widget);
	treeview = glade_xml_get_widget (xml, "search_books_list");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 0);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_visible (column, FALSE);
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 1);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start (column, renderer, TRUE);
	gtk_tree_view_column_add_attribute (column, renderer, "text", 2);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	gtk_tree_view_column_set_visible (GTK_TREE_VIEW_COLUMN (column), FALSE);
	
	store = gtk_list_store_new (3, G_TYPE_INT, G_TYPE_STRING, G_TYPE_INT);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL (store));
}

/*
 *	Funkcja usuwa wszystkie wiersze z pojedynczej listy wskazanej przez 
 *	argument 'list'
 */

void	clear_list_list					(GtkWidget	*list)	{
	GtkTreeModel	*model;
	
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	gtk_list_store_clear (GTK_LIST_STORE (model));
}

/*
 *	Funkcja usuwa wszystkie wiersze z drzewiastej listy wskazanej przez 
 *	argument 'list'
 */

void	clear_tree_list					(GtkWidget	*list)	{
	GtkTreeModel	*model;
	
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));
	
	gtk_tree_store_clear (GTK_TREE_STORE (model));
}

/*
 *	Funkcja zmienia kolor wiersza w liscie 'books_list' w oknie 'm_book_win'.
 *	ustawia kolor czerwony dla ksiazek przeznaczonych do usuniecia lub bialy
 *	dla ksiazek nie przeznaczonych do usuniecia.
 */

void	m_book_list_mark_row (GtkTreeViewColumn *col,
                		      GtkCellRenderer   *renderer,
                   			  GtkTreeModel      *model,
                 		      GtkTreeIter       *iter,
                 		      gpointer           user_data)
{
	gint	remove_val;
	
	gtk_tree_model_get (model, iter, 3, &remove_val, -1);
	if (remove_val == 0)	{
		g_object_set (renderer, "background-set", FALSE, NULL);
	}
	else if (remove_val == 1)	{
		g_object_set (renderer, "background", "red", "background-set", TRUE, NULL);
	}
}
