/***************************************************************************
 *            m_book-fun.h
 *
 *  Mon Oct 31 22:06:08 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomcio-j@o2.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <gtk/gtk.h>
#include <glib.h>
#include <stdio.h>
#include <sqlite3.h>

GtkWidget	*m_volume_dlg	[20];

/*=====================================================================
 *	Plik zawiera funkcje zwiazane tylko z obsluga ksiazek wielotomowych
 *====================================================================*/

typedef struct	{
	gint	id;
	
	gchar	title			[64];
	gchar	orginal_title	[64];
	gint	first_author;
	gint	second_author;
	gint	third_author;
	
	gint	genere;
	gint	publish_house;
	gint	language;
	gint	orginal_language;
	gint	volumes_number;
	
	gint	same_publish_year;
	gint	publish_year;
	
	gint	same_translators;
	gint	first_translator;
	gint	second_translator;
	gint	third_translator;	
	
	gchar	description			[2048];
} MultiVolSharedDataStruc;


MultiVolSharedDataStruc		*m_get_data_from_win			(GtkWidget					*widget);

void						m_prepare_book_win				(GtkWidget					*widget);

gboolean					m_check_book_data				(GtkWidget					*widget);

void						m_check_linked_book_data		(GtkWidget					*widget);

void						m_insert_book					(MultiVolSharedDataStruc	*book_data);

MultiVolSharedDataStruc		*m_select_book_data				(gint						*id);

void						m_display_book_data				(MultiVolSharedDataStruc	*book_data);

void						m_show_book_data				(GtkWidget					*widget, 
															 gint						*id);

void						m_remove_book					(gint						*id);

void						m_clear_main_win				(void);

void						m_update_book					(MultiVolSharedDataStruc	*book_data);

void						m_load_edit_win					(MultiVolSharedDataStruc	*book_data,
															 GtkWidget					*widget);

void						m_set_same_data_status			(GtkWidget					*widget,
															 gint						data_type,
															 gint						mode);
													 
void						m_control_main_win_expanders	(gint						mode);
